<?php
// +----------------------------------------------------------------------
// | 删除管理员
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\admin\controller\Auth;

use app\common\controller\_Admin;
use app\admin\model\AuthAdmin as Admin;

class admin_delete extends _Admin
{

    // 默认留空即可
    protected function initialize()
    {
        parent::initialize();
    }

    // 统一返回方法
    // $param 必留，用于接收get、post的参数传递
    public function run($param=[], $_this) {
        return $this->delete($param);
    }
    
    // 删除角色
    private function delete($param=[]) {
        $vif = $this->_where($param);
        if ($vif !== true) return $vif;

        $num = count($param);
        $i   = 0;
        foreach ($param['id'] as  $key=>$val) {
            $res = Admin::destroy($val['id']);
            if ($res != false) {
                $i++;
            }
        }
        
        return $this->_json('00', "共：{$num}条数据，成功删除：{$i}条！");
    }

    // 先检测管理员个数
    private function _where($param=[]) {
        $id = $param['id'];
        $in = '0';
        foreach ($id as $v) {
            if ($v['id'] == 1) {
                return $this->_json('01', "系统不允许删除admin账号！");
            }
            $in = ','.$v['id'];
        }

        $count = Admin::whereNotIn('id', $in)->where('status = 1')->count();
        if ($count <= 0) return $this->_json('01', "系统至少要保留一位管理员账号！");

        return true;
    }

}
