<?php
// +----------------------------------------------------------------------
// | 修改管理员
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\admin\controller\Auth;

use app\common\controller\_Admin;
use app\admin\model\AuthRole as Role;
use app\admin\model\AuthAdmin as Admin;

class admin_update extends _Admin
{

    // 默认留空即可
    protected function initialize()
    {
        parent::initialize();
    }

    // 统一返回方法
    // $param 必留，用于接收get、post的参数传递
    public function run($param=[], $_this) {
        $info = Admin::where('id', $param['id'])->find();

        if (\think\facade\Request::isAjax()) {
            return $this->update($param, $info);
        }

        $this->assign('info', $info);
        $role = Role::where('status = 1')->field('id, name')->select();
        $this->assign('role', $role);
        return $this->fetch('auth/admin/update');
    }
    
    // 修改角色
    private function update($param=[], $info) {
        $vif = $this->_where($param, $info);
        if (self::isset_empty($param, 'pwd')) {
            $param['pwd'] = md5($param['pwd'].strtotime($info['create_time']));
        } else {
            unset($param['pwd']);
        }
        if ($vif !== true) return $vif;

        $res = Admin::update($param);
        if ($res != false) {
            return $this->_json('00', '修改成功！');
        }

        return $this->_json('01', '修改失败！');
    }

    // 新增条件过滤
    private function _where($param=[], $info) {
        if (!self::isset_empty($param, 'name')) return $this->_json('01', '请输入用户名');
        if (!self::isset_empty($param, 'phone')) return $this->_json('01', '请输入手机号');

        if ($info['name'] != $param['name']) {
            $res = Admin::where('name', $param['name'])->value('id');
            if ($res) return $this->_json('01', '用户名已存在!');
        }
        
        if ($info['phone'] != $param['phone']) {
            $res = Admin::where('phone', $param['phone'])->value('id');
            if ($res) return $this->_json('01', '手机号已存在!');
        }

        return true;
    }
}
