<?php
// +----------------------------------------------------------------------
// | 数据表列表
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\admin\controller\Database;

use app\common\controller\_Admin;
use think\Db;
use think\facade\Request;
use think\facade\Config;
use org\Baksql;

class index extends _Admin
{
    // 数据库连接实例
    private $DB;

    // 默认留空即可
    protected function initialize()
    {
        parent::initialize();
        $config = Config::get();
        $this->DB = new Baksql($config['database']);
    }

    /**
     * 请求入口，统一返回方法
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1 + 2020.02.24
     * @deprecated 暂不弃用
     * @global 无
     * @param array $param 请求参数
     * @param object $_this 父类实例 
     * @return void
    */
    public function run($param=[], $_this) {
        # 获取所有表名
        $tables = $this->DB->get_dbname();
        $data   = [];

        # 执行其余查询
        foreach ($tables as $k=>$v) {
            # 表名
            $data[$k]['table'] = $v;
            # 表结构
            $res = Db::query("SHOW CREATE TABLE `{$v}`");
            $res = explode("COMMENT='", $res[0]['Create Table']);
            # 表注释
            $data[$k]['remark'] = str_replace("'",'', isset($res[1]) ? $res[1] : '');
            # 表编码
            $res = explode('CHARSET=', $res[0]);
            $data[$k]['code'] = str_replace(' ','', isset($res[1]) ? $res[1] : '');
            # 总记录数
            $res = Db::query("SELECT COUNT(1) ROWS FROM `{$v}`");
            $data[$k]['count'] = $res[0]['ROWS'];
        }

        $this->assign('tables', $data);
        return $this->fetch();
    }
    
}
