<?php
// +----------------------------------------------------------------------
// | 2、登出
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\socket\controller\action;
use think\Db;

class logout {
   
    /**
     * 统一入口
     * @todo 无
     * @author 小黄牛
     * @version v1.0.9 + 2020.04.16
     * @deprecated 暂不启用
     * @global 无
     * @param swoole $ws 实例
     * @param swoole $request 请求体信息
     * @param array $param 数据包
     * @return void
    */
    public function run($ws, $request, $param=[]) {
        # 获取动态数据
        $redis =  $ws->redis->hgetall($ws->config['websocket_redis_table'].$request->fd);
   
        if (!$redis) {
            \app\socket\controller\callback\error::run($ws, $request->fd, '非法请求');
            return false;
        }
        # 修改数据下班
        Db::startTrans();
        try {
            Db::name('user')->where('id', $redis['id'])->update([
                'client_fd' => '',
                'is_work_status' => 0
            ]);
            Db::commit();
        } catch (\Exception $e) {
            Db::rollback();
            \app\socket\controller\callback\error::run($ws, $request->fd, '服务器异常');
            return false;
        }
        # 更新swoole缓存信息
        # 销毁内存存储器
        $ws->user->del($redis['id']);
        # 销毁redis
        $ws->redis->hdel($ws->config['websocket_redis_table'].$request->fd);
        # 推送下线消息
        \app\socket\controller\callback\success::run($ws, $request->fd, '退出成功');
        # 销毁连接
        $ws->close($request->fd);
    }
    
    /**
     * 该接口文档说明
     * @author 小黄牛
     * @version v1.0.1 + 2020.02.24
    */
    public function _link() {
        return [
            // 请求参数
            'param' => [
            ],
            // 返回值
            'return' => [
                // 状态码囊括
                'action' => [
                    'success' => '请求成功', 
                    'error' => '接口错误',
                ]
            ]
        ];
    }
}
