<?php
// +----------------------------------------------------------------------
// | WebSocket日志操作
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace log;

class Slog {

    /**
     * 写入日志
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1 + 2019.05.23
     * @deprecated 暂不弃用
     * @global 无
     * @param Swoole $ws 长连接启动实例
     * @param string $title 日志内容
     * @param string $type 类型
     * @return void
    */
    public static function insert($ws, $title, $type='normal') {
        // 关闭调试模式
        if ($ws->config['log_debug'] == false) return false;
        // 换行符
        $RN = "\r\n";
        // 内容换行符
        $HF = "=========";
        // 日志路径
        $path = ROOT_PATH.__LOG__.'/'.date('Y-m-d').'/';
        if (!file_exists($path)) {
            mkdir($path);
        }
        $log_path = $path.'websocket.log';
        // 日志颜色
        $color = [
            'normal'  => '#333', // 正常
            'warning' => '#1ba1e2', // 警告
            'error'   => 'red', // 自定义错误
            'app_error' => 'red', // 系统级的错误
        ]; 
        
        $row = current(debug_backtrace());

        $html = '';
        $html .= date('Y-m-d H:i:s', time()).$HF;
        $html .= $title.$HF;
        $html .= $row['file'].$HF;
        $html .= $row['function'].$HF;
        $html .= $row['line'].$HF;
        $html .= $type.$RN;

        return file_put_contents($log_path, $html, FILE_APPEND);
    }
}
