<?php
// +----------------------------------------------------------------------
// | 微信Token校验
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace wx\sdk;

use wx\Weixins;
use think\facade\Request;

class check_token extends Weixins{
    
    /**
     * 启动入口
     * @todo 无
     * @author 小黄牛
     * @version v1.0.8 + 2020.04.10
     * @deprecated 暂不弃用
     * @global 无
     * @param string $token 微信TOKEN
     * @return void
    */
	public static function run(){
        self::get_config();
        $token = self::$config['token'];
        $request = Request::instance();
        # 获得微信发送过来的加密签名
		$signature = $request->param("signature");
		# 时间戳
		$timestamp = $request->param("timestamp");
		# 随机数
		$nonce = $request->param("nonce");
        
		# Token + 时间戳 + 随机数 = 组合成数组
		$tmpArr = [$token, $timestamp, $nonce];
		# 对数组进行升序重新排序
		sort($tmpArr, SORT_STRING);
		# 把数组for拼接成字符串
		$tmpStr = implode( $tmpArr );
		# 进行sha1加密
        $tmpStr = sha1( $tmpStr );
        
		# 接收微信向你服务器发送过来的随机字符串
        $echoStr = $request->param("echostr");
        # 写入日志
        \log\Log::init()->insert('微信认证处理：'.json_encode([
            '加密签名'=>$signature,
            '时间戳'=>$timestamp,
            '随机数'=>$nonce,
            '随机字符串'=>$echoStr,
        ]));
		# 最后与微信发送过来的加密签名进行对比，成功返回随机字符串给微信,告诉它认证通过了
		if( $tmpStr == $signature && $echoStr) {
            header('content-type:text');
            echo $echoStr;
            exit;
            // 注意，这里断点，是怕开了框架的调试模式
        }
        return false;
    }
}