<?php
// +----------------------------------------------------------------------
// | 微信菜单相关
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace wx\sdk;

use wx\Weixins;
use think\facade\Request;

class menu extends Weixins{
    
    /**
     * 获取菜单代码
     * @todo 无
     * @author 小黄牛
     * @version v1.0.8 + 2020.04.10
     * @deprecated 暂不弃用
     * @global 无
     * @return void
    */
	public static function get(){
        self::get_config();
        $actoken = \wx\sdk\access_token::get();

        $url   = self::str_url(self::$config['menu_list'], [$actoken]);
        $json  = self::https_curl($url);
        $res   = json_decode($json, true);

        if ($res['errcode'] != 0) {
            \log\Log::init()->insert('请求错误：'.$json, 'error');
            return false;
        } else {
            \log\Log::init()->insert('请求成功：'.$json);
        }

        return $res;
    }

    /**
     * 删除
     * @todo 无
     * @author 小黄牛
     * @version v1.0.8 + 2020.04.10
     * @deprecated 暂不弃用
     * @global 无
     * @return void
    */
	public static function delete(){
        self::get_config();
        $actoken = \wx\sdk\access_token::get();

        $url   = self::str_url(self::$config['menu_delete'], [$actoken]);
        $json  = self::https_curl($url);
        $res   = json_decode($json, true);

        if ($res['errcode'] != 0) {
            \log\Log::init()->insert('请求错误：'.$json, 'error');
            return false;
        } else {
            \log\Log::init()->insert('请求成功：'.$json);
        }

        return $res;
    }

    /**
     * 修改菜单
     * @todo 无
     * @author 小黄牛
     * @version v1.0.8 + 2020.04.10
     * @deprecated 暂不弃用
     * @global 无
     * @param json $menu 菜单
     * @return void
    */
	public static function update($menu){
        self::get_config();
        $actoken = \wx\sdk\access_token::get();

        $url   = self::str_url(self::$config['menu_insert'], [$actoken]);
        $json  = self::https_curl($url, $menu);
        $res   = json_decode($json, true);

        if ($res['errcode'] != 0) {
            \log\Log::init()->insert('请求错误：'.$json, 'error');
            return false;
        } else {
            \log\Log::init()->insert('请求成功：'.$json);
        }

        return $res;
    }
}