<?php
// +----------------------------------------------------------------------
// | 微信二维码
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace wx\sdk;

use wx\Weixins;
use think\facade\Request;

class qrcodes extends Weixins{
    
     /**
     * 启动入口
     * @todo 注意：不是支付二维码
     * @author 小黄牛
     * @version v1.0.8 + 2020.04.10
     * @deprecated 暂不弃用
     * @global 无
     * @param string $val 二维码参数
     * @param mixed $type 二维码的类型  1|2|3  =  临时|永久|永久的字符串参数值
     * @return string 二维码的url
    */
	public static function run($val, $type = 1) {
        # 根据类型，选择不同的二维码请求
        switch($type){
            case '1':
                $val = intval($val);
                $jsondata = '{"expire_seconds": 2592000,"action_name": "QR_SCENE","action_info":{"scene":{"scene_id": '.$val.'}}}';
                break;
            case '2':
                $val = intval($val);
                $jsondata = '{"action_name": "QR_LIMIT_SCENE","action_info":{"scene":{"scene_id": '.$val.'}}}';
                break;
            case '3':
                $jsondata = '{"action_name": "QR_LIMIT_STR_SCENE","action_info":{"scene":{"scene_str": '.$val.'}}}';
                break;
        }

        self::get_config();
        $actoken = \wx\sdk\access_token::get();
        # 使用OpenID去获取用户信息
        $url   = self::str_url(self::$config['qrcode'], [$actoken]);
        $json  = self::https_curl($url, $jsondata);
        $res   = json_decode($json, true);
        if (empty($res['ticket'])) {
            \log\Log::init()->insert('请求错误：'.$json, 'error');
            return false;
        }
        # 发送请求
        $url    = self::str_url(self::$config['qrcode_ticket'], [urlencode($res['ticket'])]);
        \log\Log::init()->insert('请求成功：'.$url);
        return $url;
    }

}