<?php
// +----------------------------------------------------------------------
// | 不基于反射机制：实现注释生成文档
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------
// echo '<pre>';
// $obj = new ApiWord();
// var_dump($obj->get_config());
// 长连接接口
//var_dump($obj->get_websocket_api());
// 长连接返回值
//var_dump($obj->get_websocket_code());
// 外部接口
//var_dump($obj->get_http_api());
//exit;

class ApiWord {
    public $list = [];

    // 抓取websocket的配置
    public function get_config() {
        return require_once dirname(dirname(__DIR__)).'/config/laf.php';
    }
    
    /**
     * 抓取HTTP外部接口
    */
    public function  get_http_api($dir='') {
        $dir = dirname(dirname(__DIR__)).'/app/'.API_NAME.'/controller/api/'; 
        $this->get_http_list($dir);
        
        $list = [];

        foreach ($this->list as $file=>$v) {
            $className = '/'.str_replace([$dir, '.php'], '', $file);
            $data['name']  = $className;
            $data['title'] = str_replace(['控制器','
'], '', $this->getLine($file, 3));
            $data['auth']  = $this->getLine($file, 9);
            $data['file']  = $file;
            $data['word']  = $this->_word($file);
            $list[] = $data;
        }
        return $list;
    }

    public function get_http_list($dir='') {      
        $resource = opendir($dir);
        while ($file = readdir($resource)) {
            if ($file !='.' && $file != '..') {
                $temp = $dir.$file;
                if (is_dir($temp)) {
                    $this->get_http_list($temp.'/');
                } else {
                    $this->list[$temp] = $file;
                }
            }
        }
        closedir($resource);
    }
    /**
     * 抓取长连接接口
    */
    public function  get_websocket_api() {
        // 设置你要生成文档的接口地址
        $dir = dirname(dirname(__DIR__)).'/app/'.API_NAME.'/controller/action/';
        if(!is_dir($dir)) return false;
        $handle = opendir($dir);
        $array  = [];
        if($handle){
            // 获取基础的控制器
            while (($fl = readdir($handle)) !== false) {
                $temp = $dir.$fl;
                if (!is_dir($temp) && $fl!='.' && $fl != '..') {
                    $className = str_replace('.php', '', $fl);
                    if ($className == 'Error') continue;

                    $data['name']  = $className;
                    $data['title'] = str_replace('控制器', '', $this->getLine($temp, 3));
                    $data['auth']  = $this->getLine($temp, 9);
                    $data['file']  = $temp;
                    $data['word']  = $this->_word($temp);
                    $array[] = $data;
                }
            }
        }
        return $this->_sort($array);
    }
    /**
     * 抓取长连接返回值状态码
    */
    public function  get_websocket_code() {
        // 设置你要生成文档的接口地址
        $dir = dirname(dirname(__DIR__)).'/app/'.API_NAME.'/controller/callback/';
        if(!is_dir($dir)) return false;
        $handle = opendir($dir);
        $array  = [];
        if($handle){
            // 获取基础的控制器
            while (($fl = readdir($handle)) !== false) {
                $temp = $dir.$fl;
                if (!is_dir($temp) && $fl!='.' && $fl != '..') {
                    $className = str_replace('.php', '', $fl);
                    if ($className == 'Error') continue;

                    $data['name']  = $className;
                    $data['title'] = str_replace('控制器', '', $this->getLine($temp, 3));
                    $data['auth']  = $this->getLine($temp, 9);
                    $data['file']  = $temp;
                    $data['word']  = $this->_word($temp);
                    $array[] = $data;
                }
            }
        }
        return $this->_sort($array);
    }

    // 接口重新排序
    public function _sort($array) {
        $list = [];
        foreach ($array as $v) {
$exp = explode('、', str_replace('
','', $v['title']));
            $list[$exp[0]] = $v;
            $list[$exp[0]]['title'] = $exp[1];
        }
        ksort($list);
        return $list;
    }

    // 获取接口文档
    public function _word($file) {
        $word = '未编写';
        $content = file_get_contents($file);
        $exp = explode('_link()', $content);

        if (!empty($exp[1])) {
            $exp = explode('}', $exp[1]);
            $exp = explode('{', $exp[0]);
            if (!empty($exp[1])) {
                $html = '';
$exp = explode("
", $exp[1]);
                foreach ($exp as $kk=>$val) {
                    if ($kk == 0) continue;
                    $x = explode('        ', $val);
                    foreach ($x as $key => $value) {
                        if ($key == 0) continue;
                        if ($value == '') $value = '        ';
                        $html .= $value;
                    }
                    $html .= "\r\n";
                }
                $word  = $html;
            }
        }

        return $word;
    }

    /**
    * 获取指定行内容
    * @todo 无
    * @author 小黄牛
    * @version v1.0.0.1 + 2018.10.08
    * @deprecated 暂不弃用
    * @global 无
    * @param string $file 文件路径
    * @param int $line 行数
    * @param int $length 指定行返回内容长度
    * @return string
    */
    private function getLine($file, $line, $length = 4096){
        $returnTxt = null;                // 初始化返回
        $i         = 1;                   // 行数
        $handle    = @fopen($file, "r");
        if ($handle) {
            while (!feof($handle)) {
                $buffer = fgets($handle, $length);
                if($line == $i) $returnTxt = str_replace(['// | ', 'Author: ', '<', '>'], '', $buffer);
                $i++;
            }
            fclose($handle);
        }
        return $returnTxt;
    }
}